"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RecipientAccount = exports.RecipientSlot = exports.RecipientSlotShare = exports.PlayerProfile = exports.RegistrationWithGames = exports.RegistrationAccount = exports.GameRegistration = exports.GameBundle = exports.GameAccount = exports.Vote = exports.PlayerDeposit = exports.ServerJoin = exports.PlayerJoin = exports.ServerAccount = exports.Nft = exports.EntryTypeGating = exports.EntryTypeTicket = exports.EntryTypeCash = exports.EntryType = exports.RecipientSlotOwnerAssigned = exports.RecipientSlotOwnerUnassigned = exports.RecipientSlotOwner = exports.TokenWithBalance = exports.Token = exports.VoteType = void 0;
const borsh_1 = require("@race-foundation/borsh");
var VoteType;
(function (VoteType) {
    VoteType[VoteType["ServerVoteTransactorDropOff"] = 0] = "ServerVoteTransactorDropOff";
    VoteType[VoteType["ClientVoteTransactorDropOff"] = 1] = "ClientVoteTransactorDropOff";
})(VoteType = exports.VoteType || (exports.VoteType = {}));
class Token {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
exports.Token = Token;
class TokenWithBalance {
    constructor(token, amount) {
        Object.assign(this, token);
        this.amount = amount;
        this.uiAmount = (Number(amount) / Math.pow(10, token.decimals)).toLocaleString();
    }
}
exports.TokenWithBalance = TokenWithBalance;
const RECIPIENT_SLOT_TYPE = {
    Nft: 0,
    Token: 1
};
class RecipientSlotOwner {
}
exports.RecipientSlotOwner = RecipientSlotOwner;
let RecipientSlotOwnerUnassigned = class RecipientSlotOwnerUnassigned extends RecipientSlotOwner {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)('string')
], RecipientSlotOwnerUnassigned.prototype, "identifier", void 0);
RecipientSlotOwnerUnassigned = __decorate([
    (0, borsh_1.variant)(0)
], RecipientSlotOwnerUnassigned);
exports.RecipientSlotOwnerUnassigned = RecipientSlotOwnerUnassigned;
let RecipientSlotOwnerAssigned = class RecipientSlotOwnerAssigned extends RecipientSlotOwner {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)('string')
], RecipientSlotOwnerAssigned.prototype, "addr", void 0);
RecipientSlotOwnerAssigned = __decorate([
    (0, borsh_1.variant)(1)
], RecipientSlotOwnerAssigned);
exports.RecipientSlotOwnerAssigned = RecipientSlotOwnerAssigned;
class EntryType {
}
exports.EntryType = EntryType;
let EntryTypeCash = class EntryTypeCash extends EntryType {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'Cash';
    }
};
__decorate([
    (0, borsh_1.field)('u64')
], EntryTypeCash.prototype, "minDeposit", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], EntryTypeCash.prototype, "maxDeposit", void 0);
EntryTypeCash = __decorate([
    (0, borsh_1.variant)(0)
], EntryTypeCash);
exports.EntryTypeCash = EntryTypeCash;
let EntryTypeTicket = class EntryTypeTicket extends EntryType {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'Ticket';
    }
};
__decorate([
    (0, borsh_1.field)('u8')
], EntryTypeTicket.prototype, "slotId", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], EntryTypeTicket.prototype, "amount", void 0);
EntryTypeTicket = __decorate([
    (0, borsh_1.variant)(1)
], EntryTypeTicket);
exports.EntryTypeTicket = EntryTypeTicket;
let EntryTypeGating = class EntryTypeGating extends EntryType {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'Gating';
    }
};
__decorate([
    (0, borsh_1.field)('string')
], EntryTypeGating.prototype, "collection", void 0);
EntryTypeGating = __decorate([
    (0, borsh_1.variant)(2)
], EntryTypeGating);
exports.EntryTypeGating = EntryTypeGating;
class Nft {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], Nft.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], Nft.prototype, "image", void 0);
__decorate([
    (0, borsh_1.field)('string')
], Nft.prototype, "name", void 0);
__decorate([
    (0, borsh_1.field)('string')
], Nft.prototype, "symbol", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('string'))
], Nft.prototype, "collection", void 0);
exports.Nft = Nft;
class ServerAccount {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], ServerAccount.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], ServerAccount.prototype, "endpoint", void 0);
exports.ServerAccount = ServerAccount;
class PlayerJoin {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], PlayerJoin.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], PlayerJoin.prototype, "position", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], PlayerJoin.prototype, "balance", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], PlayerJoin.prototype, "accessVersion", void 0);
__decorate([
    (0, borsh_1.field)('string')
], PlayerJoin.prototype, "verifyKey", void 0);
exports.PlayerJoin = PlayerJoin;
class ServerJoin {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], ServerJoin.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], ServerJoin.prototype, "endpoint", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], ServerJoin.prototype, "accessVersion", void 0);
__decorate([
    (0, borsh_1.field)('string')
], ServerJoin.prototype, "verifyKey", void 0);
exports.ServerJoin = ServerJoin;
class PlayerDeposit {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], PlayerDeposit.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], PlayerDeposit.prototype, "amount", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], PlayerDeposit.prototype, "settleVersion", void 0);
exports.PlayerDeposit = PlayerDeposit;
class Vote {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], Vote.prototype, "voter", void 0);
__decorate([
    (0, borsh_1.field)('string')
], Vote.prototype, "votee", void 0);
__decorate([
    (0, borsh_1.field)('u8')
], Vote.prototype, "voteType", void 0);
exports.Vote = Vote;
class GameAccount {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "title", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "bundleAddr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "tokenAddr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "ownerAddr", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameAccount.prototype, "settleVersion", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameAccount.prototype, "accessVersion", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(PlayerJoin)))
], GameAccount.prototype, "players", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(PlayerDeposit)))
], GameAccount.prototype, "deposits", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(ServerJoin)))
], GameAccount.prototype, "servers", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('string'))
], GameAccount.prototype, "transactorAddr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(Vote)))
], GameAccount.prototype, "votes", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('u64'))
], GameAccount.prototype, "unlockTime", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], GameAccount.prototype, "maxPlayers", void 0);
__decorate([
    (0, borsh_1.field)('u32')
], GameAccount.prototype, "dataLen", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], GameAccount.prototype, "data", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.enums)(EntryType))
], GameAccount.prototype, "entryType", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "recipientAddr", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], GameAccount.prototype, "checkpoint", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameAccount.prototype, "checkpointAccessVersion", void 0);
exports.GameAccount = GameAccount;
class GameBundle {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], GameBundle.prototype, "uri", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameBundle.prototype, "name", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], GameBundle.prototype, "data", void 0);
exports.GameBundle = GameBundle;
class GameRegistration {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], GameRegistration.prototype, "title", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameRegistration.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameRegistration.prototype, "regTime", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameRegistration.prototype, "bundleAddr", void 0);
exports.GameRegistration = GameRegistration;
class RegistrationAccount {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], RegistrationAccount.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('bool')
], RegistrationAccount.prototype, "isPrivate", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], RegistrationAccount.prototype, "size", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('string'))
], RegistrationAccount.prototype, "owner", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(GameRegistration)))
], RegistrationAccount.prototype, "games", void 0);
exports.RegistrationAccount = RegistrationAccount;
/**
 * The registration account data with games consolidated.
 */
class RegistrationWithGames {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
exports.RegistrationWithGames = RegistrationWithGames;
class PlayerProfile {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], PlayerProfile.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], PlayerProfile.prototype, "nick", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('string'))
], PlayerProfile.prototype, "pfp", void 0);
exports.PlayerProfile = PlayerProfile;
class RecipientSlotShare {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)((0, borsh_1.enums)(RecipientSlotOwner))
], RecipientSlotShare.prototype, "owner", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], RecipientSlotShare.prototype, "weights", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], RecipientSlotShare.prototype, "claimAmount", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], RecipientSlotShare.prototype, "claimAmountCap", void 0);
exports.RecipientSlotShare = RecipientSlotShare;
class RecipientSlot {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('u8')
], RecipientSlot.prototype, "id", void 0);
__decorate([
    (0, borsh_1.field)('u8')
], RecipientSlot.prototype, "slotType", void 0);
__decorate([
    (0, borsh_1.field)('string')
], RecipientSlot.prototype, "tokenAddr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(RecipientSlotShare)))
], RecipientSlot.prototype, "shares", void 0);
exports.RecipientSlot = RecipientSlot;
class RecipientAccount {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], RecipientAccount.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('string'))
], RecipientAccount.prototype, "capAddr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(RecipientSlot)))
], RecipientAccount.prototype, "slots", void 0);
exports.RecipientAccount = RecipientAccount;
//# sourceMappingURL=accounts.js.map