export interface IStorage {
    getItem(key: string): string | null;
    setItem(key: string, value: any): void;
}
export type TtlCache<T> = {
    expire: number;
    value: T;
};
/**
 * Set a cache with a `key`, and expire after `ttl` miliseconds.
 */
export declare function setTtlCache(storage: IStorage, key: string, value: any, ttl: number): void;
/**
 * Get a TTL cache value by `key`.
 */
export declare function getTtlCache<T>(storage: IStorage, key: string): T | undefined;
